'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var tslib = require('tslib');
var jsMagic = require('js-magic');
var axios = _interopDefault(require('axios'));
var catchDecorator = require('@magna_shogun/catch-decorator');

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var runtime_1 = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var runtime = (function (exports) {

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined$1; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
    return obj[key];
  }
  try {
    // IE 8 has a broken Object.defineProperty that only works on DOM objects.
    define({}, "");
  } catch (err) {
    define = function(obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunction.displayName = define(
    GeneratorFunctionPrototype,
    toStringTagSymbol,
    "GeneratorFunction"
  );

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      define(prototype, method, function(arg) {
        return this._invoke(method, arg);
      });
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      define(genFun, toStringTagSymbol, "GeneratorFunction");
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;

    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList),
      PromiseImpl
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined$1) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined$1;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined$1;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  define(Gp, toStringTagSymbol, "Generator");

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  Gp[iteratorSymbol] = function() {
    return this;
  };

  Gp.toString = function() {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined$1;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined$1, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined$1;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined$1;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined$1;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined$1;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined$1;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   module.exports 
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  Function("r", "regeneratorRuntime = r")(runtime);
}
});

var HttpRequestErrorHandler = /*#__PURE__*/function () {
  function HttpRequestErrorHandler(logger, httpRequestErrorService, strategy) {
    /**
     * @var noThrowStrategies List of strategies excluded from error throwing
     *
     * @memberof HttpRequestHandler
     */
    this.noThrowStrategies = ['reject', 'silent'];
    this.logger = logger;
    this.httpRequestErrorService = httpRequestErrorService;
    this.strategy = strategy;
  }
  /**
   * Process and Error
   *
   * @param {*} error Error instance or message
   * @throws          Request error context
   * @returns {void}
   */


  var _proto = HttpRequestErrorHandler.prototype;

  _proto.process = function process(error) {
    if (this.logger && this.logger.warn) {
      this.logger.warn('API ERROR', error);
    }

    var errorContext = error;

    if (typeof error === 'string') {
      errorContext = new Error(error);
    }

    if (this.httpRequestErrorService) {
      if (typeof this.httpRequestErrorService.process !== 'undefined') {
        this.httpRequestErrorService.process(errorContext);
      } else if (typeof this.httpRequestErrorService === 'function') {
        this.httpRequestErrorService(errorContext);
      }
    }

    if (!this.noThrowStrategies.includes(this.strategy)) {
      throw errorContext;
    }
  };

  return HttpRequestErrorHandler;
}();

/**
 * Generic Request Handler
 * It creates an Axios instance and handles requests within that instance
 * It handles errors depending on a chosen error handling strategy
 */

exports.HttpRequestHandler = /*#__PURE__*/function () {
  /**
   * Creates an instance of HttpRequestHandler
   * @param {string} baseURL      Base URL for all API calls
   * @param {number} timeout      Request timeout
   * @param {string} strategy     Error Handling Strategy
   * @param {*} logger            Instance of Logger Class
   * @param {*} httpRequestErrorService  Instance of Error Service Class
   * @memberof HttpRequestHandler
   */
  function HttpRequestHandler(_ref) {
    var _ref$baseURL = _ref.baseURL,
        baseURL = _ref$baseURL === void 0 ? '' : _ref$baseURL,
        _ref$timeout = _ref.timeout,
        timeout = _ref$timeout === void 0 ? null : _ref$timeout,
        _ref$strategy = _ref.strategy,
        strategy = _ref$strategy === void 0 ? null : _ref$strategy,
        _ref$logger = _ref.logger,
        logger = _ref$logger === void 0 ? null : _ref$logger,
        _ref$httpRequestError = _ref.httpRequestErrorService,
        httpRequestErrorService = _ref$httpRequestError === void 0 ? null : _ref$httpRequestError;

    /**
     * @var timeout Request timeout
     *
     * @memberof HttpRequestHandler
     */
    this.timeout = 30000;
    /**
     * @var strategy Request timeout
     *
     * @memberof HttpRequestHandler
     */

    this.strategy = 'silent';
    this.timeout = timeout || this.timeout;
    this.strategy = strategy || this.strategy;
    this.logger = logger || global.console || window.console || null;
    this.httpRequestErrorService = httpRequestErrorService;
    this.requestInstance = axios.create({
      baseURL: baseURL,
      timeout: this.timeout
    });
  }
  /**
   * Get Provider Instance
   *
   * @returns {AxiosInstance} Provider's instance
   * @memberof HttpRequestHandler
   */


  var _proto = HttpRequestHandler.prototype;

  _proto.getInstance = function getInstance() {
    return this.requestInstance;
  }
  /**
   * Intercept Request
   *
   * @param {*} callback callback to use before request
   * @returns {void}
   * @memberof HttpRequestHandler
   */
  ;

  _proto.interceptRequest = function interceptRequest(callback) {
    this.getInstance().interceptors.request.use(callback);
  }
  /**
   * POST Request
   *
   * @param {string} url                  Url
   * @param {*} data                      Payload
   * @param {AxiosRequestConfig} config   Config
   * @throws {Error}                      If request fails
   * @returns {Promise}                   Request response or error info
   * @memberof HttpRequestHandler
   */
  ;

  _proto.post = function post(url, data, config) {
    if (data === void 0) {
      data = null;
    }

    if (config === void 0) {
      config = null;
    }

    return this.handleRequest({
      type: 'post',
      url: url,
      data: data,
      config: config
    });
  }
  /**
   * GET Request
   *
   * @param {string} url                  Url
   * @param {*} data                      Payload
   * @param {AxiosRequestConfig} config   Config
   * @throws {Error}                      If request fails
   * @returns {Promise}                   Request response or error info
   * @memberof HttpRequestHandler
   */
  ;

  _proto.get = function get(url, data, config) {
    if (data === void 0) {
      data = null;
    }

    if (config === void 0) {
      config = null;
    }

    return this.handleRequest({
      type: 'get',
      url: url,
      data: data,
      config: config
    });
  }
  /**
   * PUT Request
   *
   * @param {string} url                  Url
   * @param {*} data                      Payload
   * @param {AxiosRequestConfig} config   Config
   * @throws {Error}                      If request fails
   * @returns {Promise}                   Request response or error info
   * @memberof HttpRequestHandler
   */
  ;

  _proto.put = function put(url, data, config) {
    if (data === void 0) {
      data = null;
    }

    if (config === void 0) {
      config = null;
    }

    return this.handleRequest({
      type: 'put',
      url: url,
      data: data,
      config: config
    });
  }
  /**
   * DELETE Request
   *
   * @param {string} url                  Url
   * @param {*} data                      Payload
   * @param {AxiosRequestConfig} config   Config
   * @throws {Error}                      If request fails
   * @returns {Promise}                   Request response or error info
   * @memberof HttpRequestHandler
   */
  ;

  _proto["delete"] = function _delete(url, data, config) {
    if (data === void 0) {
      data = null;
    }

    if (config === void 0) {
      config = null;
    }

    return this.handleRequest({
      type: 'delete',
      url: url,
      data: data,
      config: config
    });
  }
  /**
   * PATCH Request
   *
   * @param {string} url                  Url
   * @param {*} data                      Payload
   * @param {AxiosRequestConfig} config   Config
   * @throws {Error}                      If request fails
   * @returns {Promise}                   Request response or error info
   * @memberof HttpRequestHandler
   */
  ;

  _proto.patch = function patch(url, data, config) {
    if (data === void 0) {
      data = null;
    }

    if (config === void 0) {
      config = null;
    }

    return this.handleRequest({
      type: 'patch',
      url: url,
      data: data,
      config: config
    });
  }
  /**
   * HEAD Request
   *
   * @param {string} url                  Url
   * @param {*} data                      Payload
   * @param {AxiosRequestConfig} config   Config
   * @throws {Error}                      If request fails
   * @returns {Promise}                   Request response or error info
   * @memberof HttpRequestHandler
   */
  ;

  _proto.head = function head(url, data, config) {
    if (data === void 0) {
      data = null;
    }

    if (config === void 0) {
      config = null;
    }

    return this.handleRequest({
      type: 'head',
      url: url,
      data: data,
      config: config
    });
  }
  /**
   * Get Provider Instance
   *
   * @param {Error} err      Error instance
   * @returns {AxiosInstance} Provider's instance
   * @memberof HttpRequestHandler
   */
  ;

  _proto.processRequestError = function processRequestError(err) {
    return new HttpRequestErrorHandler(this.logger, this.httpRequestErrorService, this.strategy).process(err);
  }
  /**
   * Handle Request depending on used strategy
   *
   * @param {object} payload                      Payload
   * @param {string} payload.type                 Request type
   * @param {string} payload.url                  Request url
   * @param {*} payload.data                      Request data
   * @param {AxiosRequestConfig} payload.config   Config to modify request
   * @throws {Error}
   * @returns {Promise} Response Data
   * @memberof HttpRequestHandler
   */
  ;

  _proto.handleRequest =
  /*#__PURE__*/
  function () {
    var _handleRequest = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(_ref2) {
      var _extends2;

      var type, url, _ref2$data, data, _ref2$config, config, response, requestConfig, key;

      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              type = _ref2.type, url = _ref2.url, _ref2$data = _ref2.data, data = _ref2$data === void 0 ? null : _ref2$data, _ref2$config = _ref2.config, config = _ref2$config === void 0 ? null : _ref2$config;
              response = null;
              requestConfig = config || {};
              key = type === 'get' || type === 'head' ? 'params' : 'data';
              requestConfig = _extends({}, requestConfig, (_extends2 = {
                url: url,
                method: type
              }, _extends2[key] = data || {}, _extends2));
              _context.t0 = this.strategy;
              _context.next = _context.t0 === 'silent' ? 8 : _context.t0 === 'reject' ? 22 : _context.t0 === 'throwError' ? 33 : 33;
              break;

            case 8:
              _context.prev = 8;
              _context.next = 11;
              return this.requestInstance.request(requestConfig);

            case 11:
              response = _context.sent;
              _context.next = 21;
              break;

            case 14:
              _context.prev = 14;
              _context.t1 = _context["catch"](8);
              this.processRequestError(_context.t1);
              _context.next = 19;
              return new Promise(function () {
                return null;
              });

            case 19:
              response = _context.sent;
              return _context.abrupt("return", response);

            case 21:
              return _context.abrupt("break", 37);

            case 22:
              _context.prev = 22;
              _context.next = 25;
              return this.requestInstance.request(requestConfig);

            case 25:
              response = _context.sent;
              _context.next = 32;
              break;

            case 28:
              _context.prev = 28;
              _context.t2 = _context["catch"](22);
              this.processRequestError(_context.t2);
              return _context.abrupt("return", Promise.reject(_context.t2));

            case 32:
              return _context.abrupt("break", 37);

            case 33:
              _context.next = 35;
              return this.requestInstance.request(requestConfig);

            case 35:
              response = _context.sent;
              return _context.abrupt("break", 37);

            case 37:
              return _context.abrupt("return", this.processResponseData(response));

            case 38:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this, [[8, 14], [22, 28]]);
    }));

    function handleRequest(_x) {
      return _handleRequest.apply(this, arguments);
    }

    return handleRequest;
  }() // eslint-disable-next-line class-methods-use-this
  ;

  _proto.processResponseData = function processResponseData(response) {
    if (response.data) {
      // Special case of data property within Axios data object
      // This is in fact a proper response but we may want to flatten it
      // To ease developers' lives when obtaining the response
      if (typeof response.data === 'object' && response.data.data && Object.keys(response.data).length === 1) {
        return response.data.data;
      }

      return response.data;
    }

    return null;
  };

  return HttpRequestHandler;
}();

exports.HttpRequestHandler = /*#__PURE__*/tslib.__decorate([/*#__PURE__*/catchDecorator.CatchAll(function (err, ctx) {
  return ctx.processRequestError(err);
})], exports.HttpRequestHandler);

/**
 * Handles dispatching of API requests
 */

exports.ApiHandler = /*#__PURE__*/function () {
  function ApiHandler(_ref) {
    var apiUrl = _ref.apiUrl,
        apiEndpoints = _ref.apiEndpoints,
        _ref$strategy = _ref.strategy,
        strategy = _ref$strategy === void 0 ? null : _ref$strategy,
        _ref$logger = _ref.logger,
        logger = _ref$logger === void 0 ? null : _ref$logger,
        _ref$httpRequestError = _ref.httpRequestErrorService,
        httpRequestErrorService = _ref$httpRequestError === void 0 ? null : _ref$httpRequestError;

    /**
     * Api Url
     *
     * @memberof ApiHandler
     */
    this.apiUrl = '';
    this.apiUrl = apiUrl;
    this.apiEndpoints = apiEndpoints;
    this.logger = logger;
    this.httpRequestHandler = new exports.HttpRequestHandler({
      baseURL: this.apiUrl,
      strategy: strategy,
      logger: logger,
      httpRequestErrorService: httpRequestErrorService
    });
  }
  /**
   * Get Provider Instance
   *
   * @returns {AxiosInstance} Provider's instance
   * @memberof HttpRequestHandler
   */


  var _proto = ApiHandler.prototype;

  _proto.getInstance = function getInstance() {
    return this.httpRequestHandler.getInstance();
  }
  /**
   * Maps all API requests
   *
   * @param {*} prop          Caller
   * @returns {Function}      Tailored request function
   * @memberof ApiHandler
   */
  ;

  _proto.__get = function __get(prop) {
    if (prop in this) {
      return this[prop];
    } // Prevent handler from running for non-existent endpoints


    if (!this.apiEndpoints[prop]) {
      return this.handleNonImplemented.bind(this, prop);
    }

    return this.handleRequest.bind(this, prop);
  }
  /**
   * Handle Single API Request
   *
   * @param {*} args      Arguments
   * @returns {Promise}   Resolvable API provider promise
   * @memberof ApiHandler
   */
  ;

  _proto.handleRequest =
  /*#__PURE__*/
  function () {
    var _handleRequest = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee() {
      var prop,
          api,
          apiData,
          uriParams,
          uri,
          requestData,
          responseData,
          _args = arguments;
      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              prop = _args.length <= 0 ? undefined : _args[0];
              api = this.apiEndpoints[prop];
              apiData = (_args.length <= 1 ? undefined : _args[1]) || {};
              uriParams = (_args.length <= 2 ? undefined : _args[2]) || {};
              uri = api.url.replace(/:[a-z]+/ig, function (str) {
                return uriParams[str.substr(1)] ? uriParams[str.substr(1)] : str;
              });
              requestData = _extends({}, apiData);
              responseData = null;
              _context.next = 9;
              return this.httpRequestHandler[api.method](uri, requestData);

            case 9:
              responseData = _context.sent;
              return _context.abrupt("return", responseData);

            case 11:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function handleRequest() {
      return _handleRequest.apply(this, arguments);
    }

    return handleRequest;
  }()
  /**
   * Triggered when trying to use non-existent endpoints
   * @param prop Method Name
   */
  ;

  _proto.handleNonImplemented = function handleNonImplemented(prop) {
    if (this.logger && this.logger.log) {
      this.logger.log(prop + " endpoint not implemented.");
    }

    return Promise.resolve(null);
  };

  return ApiHandler;
}();

exports.ApiHandler = /*#__PURE__*/tslib.__decorate([jsMagic.applyMagic], exports.ApiHandler);

exports.HttpRequestErrorHandler = HttpRequestErrorHandler;
//# sourceMappingURL=axios-multi-api.cjs.development.js.map
