import { ErrorHandlingStrategy } from './types/http-request-handler';
export declare class HttpRequestErrorHandler {
    /**
     * Logger Class
     *
     * @type {*}
     * @memberof HttpRequestErrorHandler
     */
    logger: any;
    /**
     * Error Service Class
     *
     * @type {*}
     * @memberof HttpRequestErrorHandler
     */
    httpRequestErrorService: any;
    /**
     * @var strategy Request timeout
     *
     * @memberof HttpRequestHandler
     */
    strategy: ErrorHandlingStrategy;
    /**
     * @var noThrowStrategies List of strategies excluded from error throwing
     *
     * @memberof HttpRequestHandler
     */
    noThrowStrategies: ErrorHandlingStrategy[];
    constructor(logger: any, httpRequestErrorService: any, strategy: ErrorHandlingStrategy);
    /**
     * Process and Error
     *
     * @param {*} error Error instance or message
     * @throws          Request error context
     * @returns {void}
     */
    process(error: string | Error): void;
}
